/* Written by Yong Li, Depeng Liu                                       */
/* Copyright (c) 2016                  	                               */
/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
 /* the Free Software Foundation, either version 3 of the License, or    */
/* (at your option) any later version.                                  */

/* This program is distributed in the hope that it will be useful,      */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */

/* You should have received a copy of the GNU General Public License    */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/

package cn.ac.ios.options;


// this is class meant for command line usage

public final class Options {
	
	// mode 
	public static boolean modeInteractive = false;
	public static boolean modeAutomatic = false;
	
	// data structure used in learning algorithm
	public static boolean learnerTree = false;
	public static boolean learnerTable = false;
	
	// FDFA learning
	public static boolean learnerPeriodic = false;    // FDFA periodic method
	public static boolean learnerRecurrent = false;   // FDFA recurrent method
	public static boolean learnerSyntactic = false;   // FDFA syntactic method
	
	// Buechi construction method for FDFA
	public static boolean buechiBuildLower = false;
	//  sampling before equivalence check
	public static boolean sampleFdfa = false;
	
	// use rabit minimize
	public static boolean simulation = false;
	// use rabit minimization for Buechi
	public static boolean minimizationBuechi = false;
	
	// buechi learning algorithm by CNP and L$
	public static boolean learnerBuechi = false;
	
	// whether we need to output the corresponding LDBA, only for lower
	public static boolean outLDBA = false;
	// lazy for equivalence check, this means that
	// equivalence check will be avoided as much as possible
	public static boolean lazyEqCheck = false;
	
	// classic learning algorithm
	public static boolean learnerLStar = false;
	public static boolean learnerDFA = false;
	public static boolean learnerNFA = false;
	public static boolean learnerMultiplicity = false;
	
	// sampling as teacher
	public static boolean teacherSampling = false;
	
	// information
	public static boolean verbose = false;
	
	//tests
	public static boolean test = false;
	public static int testNumStates = 0;
	

}
